<?php 
/*
 * ----------------------------------------------
 * Lazarus Guestbook
 * by Stewart Souter
 * URL: www.carbonize.co.uk 
 * Based on Advanced Guestbook 2.3.x (PHP/MySQL)
 * Copyright (c)2001 Chi Kien Uong
 * URL: http://www.proxy2.de
 * Last Modified: 07/03/2006 21:47:03
 * ----------------------------------------------
 */

class guestbook_vars extends gbook_sql
{

   var $VARS;
   var $LANG;
   var $table = array();
   var $SMILIES;
   var $template;

   function guestbook_vars($path = '')
   {
      global $GB_TBL;
      $this->table =& $GB_TBL;
      $this->gbook_sql();
      $this->connect();
      $this->template = new gb_template($path);
   }

   function getVars()
   {
      global $_COOKIE;
      $this->VARS = $this->fetch_array($this->query("SELECT * FROM ".$this->table['cfg']));
      $this->free_result($this->result);
      if (isset($_COOKIE['lang']) && !empty($_COOKIE['lang']))
      {
         $this->template->set_lang($_COOKIE['lang']);
      }
      else
      {
         $this->template->set_lang($this->VARS['lang']);
      }
      $this->LANG =& $this->template->get_content();
      return $this->VARS;
   }

//
// This function converts a string into the relevant ascii HTML entities.
//

   function html_encode($string)
   {
      $ret_string = '';
      $len = strlen( $string );
      for ($x = 0; $x < $len; $x++) 
      {
         $ord = ord($string[$x]);
         $ret_string .= '&#'.$ord.';';
      } 
      return $ret_string;
   } 
   
//
// If they are previewing their entry we need to undo the HTMLspecialchars function
//   

   function undo_htmlspecialchars($string)
   {
      $html = array (
      '&amp;'  => '&',
      '&quot;' => '"',
      '&lt;'   => '<',
      '&gt;'   => '>'
      );
      $string = strtr($string, $html);
      return ($string);
   } 
   
//
// Lets turn our smiley codes into img tags
//      

   function emotion($message)
   {
      global $GB_PG;
      if (!isset($this->SMILIES))
      {
         $this->query("SELECT * FROM ".$this->table['smile']);
         while ($this->fetch_array($this->result))
         {
            $this->SMILIES[$this->record['s_code']] = '<img src="'.$GB_PG['base_url'].'/img/smilies/'.$this->record['s_filename'].'" width="'.$this->record['width'].'" height="'.$this->record['height'].'" alt="'.$this->record['s_emotion'].'" title="'.$this->record['s_emotion'].'" align="bottom">';
         }
      }
      if (isset($this->SMILIES))
      {
         for(reset($this->SMILIES); $key = key($this->SMILIES); next($this->SMILIES))
         {
            $message = str_replace("$key",$this->SMILIES[$key],$message);
         }
      }
      return $message;
   }

   function DateFormat($timestamp)
   {
      $timestamp += $this->VARS['offset']*3600;
      list($wday,$mday,$month,$year,$hour,$minutes,$hour12,$ampm) = split("( )",date("w j n Y H i h A",$timestamp));
      if ($this->VARS['tformat'] == 'AMPM')
      {
         $newtime = " $hour12:$minutes $ampm";
      }
      else
      {
         $newtime = " $hour:$minutes";
      }
      if ($this->VARS['dformat'] == 'ISO')
      {
         $newdate = " $year-$month-$mday";
      }
      elseif ($this->VARS['dformat'] == 'USx')
      {
         $newdate = " $month-$mday-$year";
      }
      elseif ($this->VARS['dformat'] == 'US')
      {
         $month -= 1;
         $newdate = $this->template->WEEKDAY[$wday].", ".$this->template->MONTHS[$month]." $mday, $year";
      }
      elseif ($this->VARS['dformat'] == 'Euro')
      {
         $month -= 1;
         $newdate = $this->template->WEEKDAY[$wday].", $mday ".$this->template->MONTHS[$month]." $year";
      }
      else
      {
         $newdate = "$mday.$month.$year";
      }
      return ($newdate=$newdate.$newtime);
   }
   
   function AGCode($string)
   {
      $string = ' '.$string;
      if ($this->VARS['allow_urlagcode'] == 1)
      {
         // This bit will automatically make any urls clickable
         // It is taken from phpBB. Thanks guys.
         $string = preg_replace("#(^|[\n ])([\w]+?://[\w\#$%&~/.\-;:=,?@\[\]+]*)#is", "$1[url]$2[/url]", $string);
         $string = preg_replace("#(^|[\n ])((www|ftp)\.[\w\#$%&~/.\-;:=,?@\[\]+]*)#is", "$1[url]$2[/url]", $string);      
      }
      // No point doing these checks if there is no AGcode
      if (!(strpos($string, '[') && strpos($string, ']')))
      {
         $string = substr($string, 1);
         return $string;
      }
      $string = preg_replace("/\[b\](.+?)\[\/b\]/is","<b>$1</b>",$string);
      $string = preg_replace("/\[i\](.+?)\[\/i\]/is","<i>$1</i>",$string);
      $string = preg_replace("/\[u\](.+?)\[\/u\]/is","<u>$1</u>",$string);
      $string = preg_replace("/\[email\]([a-z0-9\-_\.\+]+@[a-z0-9\-]+\.[a-z0-9\-\.]+?)\[\/email\]/ies", "'<a href=\"'.\$this->html_encode('mailto:$1').'\">'.\$this->html_encode('$1').'</a>'", $string);
      if ($this->VARS['allow_imgagcode'] == 1)
      {
         $string = eregi_replace("\[img\](http://[^\[]+)\[/img\]","<img src=\"\\1\" border=\"0\" alt=\"\">",$string);
      }
      if ($this->VARS['allow_urlagcode'] == 1)
      {
         $string = eregi_replace("\\[url\\]www\\.", "[url]http://www.", $string);
         $string = preg_replace("/\[url\]((http|https|ftp|mailto):\/\/([a-z0-9\.\-@:]+)[a-z0-9;\/\?:@=\&\$\-_\.\+!*'\(\),\#%~]*?)\[\/url\]/is","[<a href=\"$1\" target=\"_blank\" rel=\"nofollow\" title=\"$1\">$3</a>]",$string);
         $string = preg_replace("/\[url=((http|https|ftp|mailto):\/\/[a-z0-9;\/\?:@=\&\$\-_\.\+!*'\(\),~%#]+?)\](.+?)\[\/url\]/is","<a href=\"$1\" target=\"_blank\" title=\"$1\" rel=\"nofollow\">$3</a>",$string);
      }
      $string = substr($string, 1);
      return $string;
   }

//
// Code to allow certain HTML tags
//
    
   function allowed_html($string)
   {
      $allowed_tags = split(',', $this->VARS['allowed_tags']);
      for ($i = 0; $i <= (count($allowed_tags) - 1); $i++)
      {
         $allowed_tags[$i] = trim($allowed_tags[$i]);
         $string = eregi_replace("&lt;$allowed_tags[$i]&gt;([^\\[]*)&lt;/$allowed_tags[$i]&gt;","<$allowed_tags[$i]>\\1</$allowed_tags[$i]>", $string);
      }
      return $string;
   }

//
// Remove spaces from the ends of the strings and any double spaces from the middle
//

   function FormatString($strg)
   {
      $strg = trim($strg);
      $strg = ereg_replace("[ ]+", " ", $strg);
      return $strg;
   }

//
// Make sure there are now stupidly long or short words
//

   function CheckWordLength($strg)
   {
      $word_array = split ("[ |\n]",$strg);
      for ($i=0;$i<sizeof($word_array);$i++)
      {
         if ((ereg("^\\[(url|img|email)\\].+\\]",$word_array[$i])) || (eregi("^(http://)|(https://)|(ftp://)|(www\\.)", $word_array[$i])))
         {
            if (strlen($word_array[$i]) > 150)
            {
               return false;
            }
         }
         elseif (strlen($word_array[$i]) > $this->VARS['max_word_len'])
         {
            return false;
         }
      }
      return true;
   }

   function isBannedIp($ip)
   {
      $this->query("SELECT * from ".$this->table['ban']);
      if (!$this->result)
      {
         return false;
      }
      while ($row = $this->fetch_array($this->result))
      { 
         if ((strpos($ip, $row['ban_ip'])) === 0)
         {
            return true;
         }
      }
      return false;
   }

   function FloodCheck($ip)
   {
      $the_time = time()-$this->VARS['flood_timeout'];
      $this->query("DELETE FROM ".$this->table['ip']." WHERE (timestamp < $the_time)");
      $this->query("SELECT * FROM ".$this->table['ip']." WHERE (guest_ip = '$ip')");
      $this->fetch_array($this->result);
      return ($this->record) ? true : false;
   }

   function CensorBadWords($strg)
   {
      $replace = '#@*%!';
      $this->query("select * from ".$this->table['words']);
      if ($this->VARS['use_regex'] == 0)
      {
         while ($row = $this->fetch_array($this->result))
         {
            $row['word'] = preg_quote($row['word'], '/');
            $strg = preg_replace('/'.$row['word'].'/i', $replace, $strg);
            //$row['word'] = ereg_replace("\\^|\\\\|\\.|\\\$|\\(|\\)|\\||\\*|\\?|\\{|\\}|\\[|\\]\\+|\\:|\\-", '\\\\\\0', $row['word']);
            //$strg = eregi_replace($row['word'], $replace, $strg);
         }
      }
      else
      {
         while ($row = $this->fetch_array($this->result))
         {
            $strg = preg_replace('/'.$row['word'].'/i', $replace, $strg);
           //$strg = eregi_replace($row['word'], $replace, $strg);
         }
      }
      return $strg;
   }
   
   function BlockBadWords($strg)
   {
      $this->query("select * from ".$this->table['words']);
      if ($this->VARS['use_regex'] == 0)
      {
         while ($row = $this->fetch_array($this->result))
         {
            $row['word'] = preg_quote($row['word'], '/');
            //$row['word'] = ereg_replace("\\^|\\\\|\\.|\\\$|\\(|\\)|\\||\\*|\\?|\\{|\\}|\\[|\\]\\+|\\:|\\-", '\\\\\\0', $row['word']);
            if (eregi($row['word'], $strg))
            {
               return true;
            }
         }
      }
      else
      {
         while ($row = $this->fetch_array($this->result))
         {
            //if (eregi($row['word'], $strg))
            if (preg_match('/'.$row['word'].'/i', $strg))
            {
               return true;
            }
         }
      }
      return false;
   }   

   function gb_error($ERROR)
   {
      global $GB_PG;
      $LANG =& $this->LANG;
      $VARS =& $this->VARS;
      $EMAILJS = '';
      $error_html = '';
      eval("\$error_html = \"".$this->template->get_template('header')."\";");
      eval("\$error_html .= \"".$this->template->get_template('error')."\";");
      eval("\$error_html .= \"".$this->template->get_template('footer')."\";");
      return $error_html;
   }
   
   function browser_detect($useragent)
   {
      $browsers = array('firefox', 'opera', 'konqueror', 'netscape', 'aol', 'camino', 'chimera', 'crazy', 'galeon', 'k-meleon', 'maxthon', 'safari', 'slimbrowser', 'amaya', 'avantbrowser', 'msie', 'gecko', 'mozilla');
      for ($i=0;$i<sizeof($browsers);$i++)
      {
         if (eregi($browsers[$i], $useragent))
         {
            $theirbrowser = $browsers[$i];
            $theirbrowser = ($theirbrowser == 'mozilla') ? 'ns' : $theirbrowser;
            $theirbrowser = ($theirbrowser == 'gecko') ? 'mozilla' : $theirbrowser;
            break;
         }
      }
      $theirbrowser = (!isset($theirbrowser)) ? 'question' : $theirbrowser;
      return $theirbrowser;
   }
   
}
?>